﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Com.Piwigo.Lib.IService;
using Com.Piwigo.Lib.DTO;

using Com.Piwigo.Uploader.DTO;

namespace Com.Piwigo.Uploader.Service
{
    public class Connect: IService 
    {          
        public void runService()
        {
            PwgServiceProvider.Instance.PwgSetupService.Setup("UploadToPiwigo", null, ModelManager.Instance.serveurName);

            System.Diagnostics.Debug.WriteLine(ModelManager.Instance.serveurName.AbsoluteUri);

            try
            {
                ModelManager.Instance.sess = PwgServiceProvider.Instance.PwgSessionService.Login( ModelManager.Instance.userName,  ModelManager.Instance.password);
                System.Diagnostics.Debug.WriteLine("user : " + ModelManager.Instance.sess.UserName + " " + ModelManager.Instance.sess.Status);

                if (ModelManager.Instance.sess.Status == PwgSessionStatusEnum.WebMaster)
                {
                    ModelManager.Instance.lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetAdminListOfCategory();
                }
                else
                {
                    ModelManager.Instance.lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetListOfCategory(PwgCategory.RootCategoryId, true, false);
                }

            }
            catch (PwgServiceException ex)
            {
                System.Diagnostics.Debug.WriteLine(ex.Message);
                throw new ApplicationException ("Erreur " + ex.NumeroErr + " " + ex.MessageErr);
            }
        }
    }
}
