﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Com.Piwigo.Uploader.Service
{
    static class ServiceFactory
    {
        public static IService GetByType<T>()
        {
            IService objICom;

            switch (typeof(T).Name)
            {
                case "Connect":
                    objICom = aConnect;
                    break;
                case "Disconnect":
                    objICom = aDisconnect;
                    break;
                case "LoadFromDirectory":
                    objICom = aLoadFromDirectory;
                    break;
                default:
                    throw new ArgumentException("ServiceFactory GetByType : IService Type unknow.", "Type");
            }

            return objICom;
        }

        private static IService _aConnect;
        private static IService aConnect
        {
            get
            {
                if (_aConnect == null)
                {
                    _aConnect = new Connect();
                }
                return _aConnect;
            }
        }

        private static IService _aDisconnect;
        private static IService aDisconnect
        {
            get
            {
                if (_aDisconnect == null)
                {
                    _aDisconnect = new Disconnect();
                }
                return _aDisconnect;
            }
        }

        private static IService _aLoadFromDirectory;
        private static IService aLoadFromDirectory
        {
            get
            {
                if (_aLoadFromDirectory == null)
                {
                    _aLoadFromDirectory = new LoadFromDirectory();
                }
                return _aLoadFromDirectory;
            }
        }
    }
}
